import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrKnowledgepoint {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  GradeLevel!: IType<number, bigint>;
  SubjectId!: IType<number, bigint>;
  Name?: string;
  Color?: string;
  ParentId!: IType<number, bigint>;
  Level!: number;
  Sort!: number;
  Type!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrKnowledgepointSchema = defineEntity({
  class: IcrKnowledgepoint,
  comment: '知识点;',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    GradeLevel: p.bigint().name('GradeLevel').columnType('bigint').comment('年级'),
    SubjectId: p.bigint().name('SubjectId').columnType('bigint').comment('学科Id').index('idx_ICR_KnowledgePoint_01'),
    Name: p.string().name('Name').nullable().comment('名称').index('idx_ICR_KnowledgePoint_03'),
    Color: p.string().name('Color').nullable().comment('颜色'),
    ParentId: p.bigint().name('ParentId').columnType('bigint').comment('父Id').index('idx_ICR_KnowledgePoint_02'),
    Level: p.integer().name('Level').comment('级别'),
    Sort: p.integer().name('Sort').comment('排序'),
    Type: p.integer().name('Type').comment('分类(1-知识点 2-方法)'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
